diff -u --recursive --new-file channels/chan_h323.c.orig channels/chan_h323.c
--- channels/chan_h323.c.orig	Thu Apr 21 22:31:17 2005
+++ channels/chan_h323.c	Thu Apr 21 22:31:17 2005
@@ -559,6 +559,7 @@
 static int oh323_digit(struct ast_channel *c, char digit)
 {
 	struct oh323_pvt *p = (struct oh323_pvt *) c->tech_pvt;
+	char *token;
 	if (h323debug)
 		ast_log(LOG_DEBUG, "Sending digit %c on %s\n", digit, c->name);
 	if (!p)
@@ -569,10 +570,15 @@
 	}
 	/* If in-band DTMF is desired, send that */
 	if ((p->dtmfmode & H323_DTMF_INBAND)) {
-		h323_send_tone(p->cd.call_token, digit);
+		token = p->cd.call_token ? strdup(p->cd.call_token) : NULL;
+		ast_mutex_unlock(&p->lock);
+		h323_send_tone(token, digit);
+		if (token)
+			free(token);
+		oh323_update_info(c);
 	}
-	ast_mutex_unlock(&p->lock);
-	oh323_update_info(c);
+	else
+		ast_mutex_unlock(&p->lock);
 	return 0;
 }
 
